/*
 * Name:    mptk_main.c
 *
 * Purpose: This file contains the initialization function and method table
 *          for the MpTkPrivate module interface to the MX library and Tkinter.
 *          Python programs should not invoked this module directly but should
 *          invoke the MpTk module in 'MpTk.py' instead.
 *
 * Author:  William Lavender
 *
 *---------------------------------------------------------------------------
 *
 * Copyright 2002 Illinois Institute of Technology
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "Python.h"

#include "mx_util.h"

#include "mptk.h"

/* Method table for the MpTkPrivate module. */

static PyMethodDef MpTkMethods[] = {
	{ "install_user_interrupt_handler",
			MpTkPrivate_install_user_interrupt_handler_cmd,
			METH_VARARGS },
	{ "install_output_handlers",
			MpTkPrivate_install_output_handlers_cmd,
			METH_VARARGS },
	{ "install_dialog_handler",
			MpTkPrivate_install_dialog_handler_cmd,
			METH_VARARGS },

	{ NULL, NULL }
};

/* This is MpTkPrivate's module initialization function. */

MX_EXPORT void
initMpTkPrivate( void )
{
	(void) Py_InitModule("MpTkPrivate", MpTkMethods);
}

/* MpTkPrivate_process_tkinter_events() invokes 'update' to cause
 * outstanding Tkinter events to be processed.
 */

MX_EXPORT mx_status_type
MpTkPrivate_process_tkinter_events( void )
{
	(void) PyRun_SimpleString( "Tkinter.tk.eval(\"update\")" );

	return MX_SUCCESSFUL_RESULT;
}

